<template>
  <view class="page-raw-receipt">
    <view class="header" :style="{ backgroundColor: `rgba(23, 83, 234, ${scrollTop / 100})` }">
      <view class="left">
        <u-icon class="icon" name="arrow-left" @click="uni.navigateBack()" />
      </view>
      <view class="title">{{ $t('message.Pi_PickingQuery') }}</view>
      <view class="right"></view>
    </view>
    <u-form class="form" ref="form" :model="form" :error-type="['toast']" label-width="120rpx">
      <u-row align="top">
        <u-col :span="12">
          <!-- MRP -->
          <u-form-item :required="true" label="MRP" prop="mrpCodeRegion">
            <u-input v-model="form.mrpCodeRegion" :placeholder="$t('message.po_PleaseInput')" />
          </u-form-item>
          <!-- 订单号 -->
          <u-form-item :label="$t('message.Pi_OrderNo')">
            <u-input v-model="form.prdOrderFrom" :placeholder="$t('message.po_PleaseInput')" />
          </u-form-item>
          <!-- 工厂 -->
          <u-form-item :required="true" :label="$t('message.Pi_factory')" prop="sapFactoryCode">
            <u-input v-model="form.sapFactoryCode" :placeholder="$t('message.po_PleaseInput')" />
          </u-form-item>
          <!-- 物料号 -->
          <u-form-item :label="$t('message.Pi_materielNo')">
            <u-input v-model="form.materialCodeList" style="padding-left: 14px" :placeholder="$t('message.po_PleaseInput')" />
          </u-form-item>
        </u-col>
        <u-col :span="12">
          <view class="table-wrapper">
            <wyb-table class="table" ref="table" width="100%" enable-check="multiple" show-left-and-right-border :headers="headers" :contents="model.proOrderList" :show-vert-border="false"></wyb-table>
          </view>
        </u-col>
      </u-row>
    </u-form>
    <view class="bottom-bar">
      <u-row class="button-bar">
        <u-col :span="6">
          <u-button type="primary" @click="onQuery">{{ $t('message.Pi_order') }}</u-button>
        </u-col>
        <u-col :span="3">
          <u-button type="success" @click="onOk">{{ $t('message.dn_Confirm') }}</u-button>
        </u-col>
        <u-col :span="3">
          <u-button type="error" @click="uni.navigateBack()">{{ $t('message.po_Return') }}</u-button>
        </u-col>
      </u-row>
    </view>
  </view>
</template>

<script lang="ts">
import { Component, Ref, Watch } from 'vue-property-decorator';
import { BasePage } from '@/components/base/page';
import { VForm } from 'vue/types/form';
import model from './model';
import { headers } from './config';
import http from '@/utils/request';
import { url } from '@/utils/url';
import { session } from '@/store/modules/session';

@Component
export default class pickingDom extends BasePage {
  /**
   * 表单引用
   */
  @Ref('form') readonly $form!: VForm;

  @Watch('form', { immediate: true, deep: true })
  onPersonChanged() {
    this.isFormChange = true;
  }

  /**
   * 页面Module
   */
  model = model;

  /**
   * 表头
   */
  headers = headers;
  /**
   * 表单数据
   */
  form = {
    mrpCodeRegion: '',
    mrpCodeIncludeList: '',
    mrpCodeExcludeList: '',
    prdOrderFrom: '',
    prdOrderTo: '',
    sapFactoryCode: '',
    wkposCode: '',
    batchNumberList: '',
    materialCodeList: '',
    sendSpotList: '',
  };

  /**
   * 表单是否改变
   */
  isFormChange = false;

  /**
   * 选择项显示
   */
  requireDateRegionSelect = false;
  productDateRegionSelect = false;

  /**
   * 表单校验
   */
  rules = {
    mrpCodeRegion: [{ required: true, message: this.$t('message.Pi_InputMrp') as string }],
    sapFactoryCode: [{ required: true, message: this.$t('message.Pi_InputFactory') as string }],
  };

  /**
   * 生成表单参数
   */
  get formParams() {
    const params: any = {
      ...this.form,
      factoryCode: session.factoryCode,
      loginName: session.loginName,
    };
    if (this.form.batchNumberList) {
      params.batchNumberList = this.form.batchNumberList.split(',');
    } else {
      delete params.batchNumberList;
    }
    if (this.form.materialCodeList) {
      params.materialCodeList = this.form.materialCodeList.split(',');
    } else {
      delete params.materialCodeList;
    }
    if (this.form.mrpCodeIncludeList) {
      params.mrpCodeIncludeList = this.form.mrpCodeIncludeList.split(',');
    } else {
      delete params.mrpCodeIncludeList;
    }
    if (this.form.mrpCodeExcludeList) {
      params.mrpCodeExcludeList = this.form.mrpCodeExcludeList.split(',');
    } else {
      delete params.mrpCodeExcludeList;
    }
    if (this.form.sendSpotList) {
      params.sendSpotList = this.form.sendSpotList.split(',');
    } else {
      delete params.sendSpotList;
    }
    return params;
  }
  // 必须要在onReady生命周期，因为onLoad生命周期组件可能尚未创建完毕
  onReady() {
    this.$form.setRules(this.rules);
    model.clearProOrderList();
    this.form.sapFactoryCode = session.factoryCode;
  }

  /**
   * 确认
   */
  onOk() {
    this.$form.validate(async (valid: boolean) => {
      if (!valid) return;
      let orderOutIdList = [];
      if (this.isFormChange || this.model.proOrderList.length === 0) {
        const { list: proOrderList }: any = await http.post(url.sortscan.query.prdorder, this.formParams);
        orderOutIdList = proOrderList.map((_: any) => _.orderOutId);
      } else {
        orderOutIdList = this.model.checkedProOrderList.map((_: any) => _.orderOutId);
      }
      if (orderOutIdList.length === 0 && this.model.proOrderList.length > 0) {
        this.customToast(this.$t('message.Pi_OrderNoNotSelected') as string);
        return;
      } else if (orderOutIdList.length === 0) {
        this.customToast(this.$t('message.Pi_NoDataFound') as string);
        return;
      }
      const params = {
        sapFactoryCode: this.form.sapFactoryCode,
        factoryCode: session.factoryCode,
        loginName: session.loginName,
        orderOutIdList,
      };
      this.model.NEWparams = params;
      await this.model.queryProOrderResult(params);
      sessionStorage.setItem('factory', JSON.stringify(params) as any);
      this.toPage(this.page.raw.handover.picking.result);
    });
  }

  /**
   * 订单查询
   */
  onQuery() {
    this.$form.validate(async (valid: boolean) => {
      if (!valid) return;
      await this.model.queryProOrder(this.formParams);
      this.model.checkAllProOrderList(true);
      this.isFormChange = false;
      model.mrpCodeRegion = this.form.mrpCodeRegion as any;
      model.sapFactoryCode = this.form.sapFactoryCode as any;
      model.formParams = this.formParams;
    });
  }
}
</script>

<style lang="scss" scoped>
.page-raw-receipt {
  background: #f2f2f2 linear-gradient(0deg, #f2f2f2 0%, #4a78ea 51%, #1753ea 100%) no-repeat;
  background-size: 100% 600rpx;
  padding: 118rpx 30rpx 162rpx;
  min-height: 100%;

  .header {
    position: fixed;
    top: 36rpx;
    left: 0;
    right: 0;
    z-index: 99;
    display: flex;
    height: 88rpx;
    line-height: 88rpx;
    color: #fff;
    font-size: 34rpx;
    font-weight: 500;
    text-align: center;
    .title {
      flex: 3;
    }
    .left,
    .right {
      flex: 1;
    }
    .icon {
      display: flex;
      justify-content: center;
      align-items: center;
      width: 88rpx;
      height: 88rpx;
    }
  }

  .form {
    background-color: #fff;
    padding: 30rpx;
    border-radius: 10rpx;
    box-shadow: 0 0 20rpx 0 rgba(128, 128, 128, 0.2);

    .u-form-item {
      padding: 30rpx 0;
      line-height: 35rpx;
    }
  }

  .table-wrapper {
    padding: 10rpx 0;
  }

  .bottom-bar {
    position: fixed;
    bottom: 0;
    left: 0;
    right: 0;
    z-index: 99;
    background: #ffffff;
    box-shadow: 0 1rpx 20rpx 0 rgba(128, 128, 128, 0.2);
    padding: 20rpx;
  }

  .button-bar {
  }
}
</style>
